/***********************************************************************************************************************
 *
 * blueMarine Semantic - open source media workflow
 * Copyright (C) 2008-2011 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://bluemarine.tidalwave.it
 * SCM: https://kenai.com/hg/bluemarine~semantic-src
 *
 **********************************************************************************************************************/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package it.tidalwave.semantic.persistence;

import javax.annotation.Nonnull;
import org.openide.util.lookup.ServiceProvider;
import it.tidalwave.aspect.Aspect;
import it.tidalwave.aspect.AspectFactory;
import it.tidalwave.netbeans.util.Locator;
import it.tidalwave.semantic.persistence.impl.ElmoTransactionalAspect;
import org.openrdf.elmo.ElmoModule;
import org.openrdf.elmo.sesame.SesameManagerFactory;
import org.openrdf.repository.Repository;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: TransactionalAspectFactory.java,v 4fbb06e9364c 2011/03/06 21:25:16 fabrizio $
 *
 **********************************************************************************************************************/
@ServiceProvider(service=TransactionalAspectFactory.class)
public class TransactionalAspectFactory implements AspectFactory
  {
    private SesameManagerFactory smf;

    private ElmoModule elmoModule;

    public TransactionalAspectFactory()
      {
        try
          {
            final SemanticPersistence semanticPersistence = Locator.find(SemanticPersistence.class);
            final Repository repository = semanticPersistence.findRepositoryByName("DEFAULT");
            elmoModule = new ElmoModule();
            smf = new SesameManagerFactory(elmoModule, repository);
          }
        catch (NoSuchContextException e)
          {
            throw new RuntimeException(e);
          }
      }

    @Override @Nonnull
    public Aspect createAspect()
      {
        return new ElmoTransactionalAspect(smf);
      }
  }
